Gentoo Websites Logo
Go to: Gentoo Home Documentation Forums Lists Bugs Planet Store Wiki Get Gentoo!
Bug 697630 - virtual/pam being masked without consumers being revbumped
Summary: virtual/pam being masked without consumers being revbumped
Status: RESOLVED WONTFIX
Alias: None
Product: Gentoo Linux
Classification: Unclassified
Component: Current packages (show other bugs)
Hardware: All Linux
: Normal normal (vote)
Assignee: Mikle Kolyada
URL:
Whiteboard:
Keywords:
Depends on:
Blocks:
 
Reported: 2019-10-13 14:57 UTC by Brandon Penglase
Modified: 2019-10-16 18:27 UTC (History)
8 users (show)

See Also:
Package list:
Runtime testing required: ---


Attachments

Note You need to log in before you can comment on or make changes to this bug.
Description Brandon Penglase 2019-10-13 14:57:12 UTC
Per masking:
# Michał Górny <mgorny@gentoo.org> (2019-10-11)
# FreeBSD-only packages.  The project has been discontinued,
# and the core FreeBSD packages are already gone.
# Removal in 14 days.  Bug #683284.

However this package is still required by several others:
  virtual/pam-0-r1 pulled in by:
    dev-db/mariadb-10.4.8 requires virtual/pam:0/0=
    sys-apps/shadow-4.7 requires virtual/pam:0/0=
    sys-apps/systemd-243 requires virtual/pam:0/0=[abi_x86_64(-)]


Reproducible: Always

Steps to Reproduce:
1. emerge -C virtual/pam
2. emerge -uDN world

Actual Results:  
The following mask changes are necessary to proceed:
 (see "package.unmask" in the portage(5) man page for more details)
# required by dev-db/mariadb-10.4.8::gentoo
# required by virtual/mysql-5.6-r12::gentoo
# required by media-radio/cqrlog-2.3.0-r1::gentoo
# required by @selected
# required by @world (argument)
# /var/db/repos/gentoo/profiles/package.mask:
# Michał Górny <mgorny@gentoo.org> (2019-10-11)
# FreeBSD-only packages.  The project has been discontinued,
# and the core FreeBSD packages are already gone.
# Removal in 14 days.  Bug #683284.
=virtual/pam-0-r1
Comment 1 Andreas Sturmlechner gentoo-dev 2019-10-13 15:01:07 UTC
It's only required until you rebuild those packages.
Comment 2 Brandon Penglase 2019-10-13 15:27:47 UTC
(In reply to Andreas Sturmlechner from comment #1)
> It's only required until you rebuild those packages.

Ahh, I see. Indeed once those packages were rebuilt, it was required anymore. Should a message be added to the block to indicate they need to be rebuilt?
Comment 3 Andrei Slavoiu 2019-10-13 17:24:11 UTC
If those packages were revbumped there would be no need for manual rebuild by all users.
Comment 4 Erik Quaeghebeur 2019-10-13 19:41:14 UTC
(In reply to Brandon Penglase from comment #2)
> […] Should a message be added to the block to indicate they need to be
> rebuilt?

I think this is the least that should be done. It will avoid a lot of people having to waste time looking around. (It would've saved me 15 minutes. Multiply that by a couple of thousand?)
Comment 5 Ulenrich 2019-10-13 20:25:42 UTC
(In reply to Andrei Slavoiu from comment #3)
> If those packages were revbumped there would be no need for manual rebuild
> by all users.

That doesn't solve climate change. Instead I moved the virtual/pam to my local overlay and inserted one line into /etc/portage/package.unmask:
=virtual/pam-0-r1

I hope this will save my planet, because I hopefully don't need to recompile
    dev-db/mariadb-10.3.18 
    sci-mathematics/rstudio-1.2.1335 
    sys-apps/shadow-4.6
    sys-apps/systemd-242-r7

Can someone advertise this a way Greta would go?
Comment 6 Ulenrich 2019-10-13 20:33:16 UTC
Should I open a new Meta bug called:

Gretas bug to solve the climate crisis

with its first dependency to this bug?
Comment 7 Andrei Slavoiu 2019-10-13 21:57:15 UTC
(In reply to Ulenrich from comment #5)
> That doesn't solve climate change.

No, for that you need to enable ccache in your portage's FEATURES, that way a rebuild of a package that doesn't actually change the output will be done in seconds with minimal power consumption.
Comment 8 Alessandro Barbieri 2019-10-13 23:29:16 UTC
(In reply to Ulenrich from comment #5)
> (In reply to Andrei Slavoiu from comment #3)
> > If those packages were revbumped there would be no need for manual rebuild
> > by all users.
> 
> That doesn't solve climate change. Instead I moved the virtual/pam to my
> local overlay and inserted one line into /etc/portage/package.unmask:
> =virtual/pam-0-r1

Or you can add virtual/pam-0-r1 to /etc/portage/profile/package.provided
Comment 9 Chris Slycord 2019-10-14 04:00:59 UTC
(In reply to Brandon Penglase from comment #2)
> (In reply to Andreas Sturmlechner from comment #1)
> > It's only required until you rebuild those packages.
> 
> Ahh, I see. Indeed once those packages were rebuilt, it was required
> anymore. Should a message be added to the block to indicate they need to be
> rebuilt?

It's also of note that using equery to find the packages didn't do anything, because equery is checking the packages as they are in the tree (which don't have that dependency) and emerge is borking because the installed package (in /var/db/pkg) has the dependency.

I only saw which installed package was dependent on it after I removed /virtual/pam and then tried running emerge again after it.
Comment 10 Tomáš Mózes 2019-10-14 04:30:53 UTC
# rebuild shadow with sys-libs/pam dependency and remove virtual/pam
emerge -av1 sys-apps/shadow && emerge -avC virtual/pam

Another notable consumer is dev-db/mariadb, so you just re-emerge it and you are good to go.
Comment 11 Marek Bartosiewicz 2019-10-14 07:08:28 UTC
(In reply to Ulenrich from comment #6)
> Should I open a new Meta bug called:
> 
> Gretas bug to solve the climate crisis
> 
> with its first dependency to this bug?

I would start with dev-python/carbon as a candidate for removal.
Comment 12 Joakim Tjernlund 2019-10-14 10:20:07 UTC
Got quite a few here:

# > qdepends -q -Q virtual/pam
lxde-base/lxdm-0.5.3-r2: virtual/pam
mate-extra/mate-screensaver-1.22.1: virtual/pam
net-mail/mailutils-3.4-r3: virtual/pam
net-mail/mailbase-1.5-r1: virtual/pam
net-ftp/ftpbase-0.01-r3: virtual/pam
net-ftp/vsftpd-3.0.3-r2: virtual/pam
net-dialup/ppp-2.4.7-r7: virtual/pam
net-dialup/freeradius-3.0.18-r1: virtual/pam
x11-misc/i3lock-2.10: virtual/pam
gnome-base/gnome-keyring-3.28.2: virtual/pam
dev-db/postgresql-11.4: virtual/pam
net-fs/samba-4.9.13: virtual/pam
net-fs/cifs-utils-6.9-r1: virtual/pam
net-print/cups-2.2.12: virtual/pam
app-emulation/lxc-3.1.0-r1: virtual/pam
dev-libs/cyrus-sasl-2.1.27-r2: >=virtual/pam-0-r1[abi_x86_64(+)]
dev-libs/libpwquality-1.4.0: virtual/pam
net-misc/openssh-8.0_p1-r4: virtual/pam
app-misc/screen-4.6.1: virtual/pam
app-admin/sudo-1.8.27-r1: virtual/pam
sys-auth/pam_krb5-4.6: virtual/pam
sys-auth/elogind-241.3: virtual/pam
sys-auth/polkit-0.115-r4: virtual/pam
sys-libs/libcap-2.26-r2: virtual/pam[abi_x86_64(+)]
sys-process/cronie-1.5.4: virtual/pam
sys-apps/openrc-0.41.2: virtual/pam
sys-apps/kbd-2.0.4: virtual/pam
kde-plasma/kscreenlocker-5.16.5: virtual/pam
kde-plasma/kwallet-pam-5.16.5: virtual/pam
Comment 13 Oleh 2019-10-14 15:00:06 UTC
this is perhaps one more mishandle/missing functionality of portage regarding sub-slot operators. Might be the failure of consistent dep resolution when deps recorded in VDB (/var/db/pkg, normally). It is safe to manually change all of virtual/pam to sys-libs/pam in /var/db/pkg/*/*/*DEPEND (by power of sed, etc)
Perhaps, it is worth of small news with this change covered. It, then, requires no rebuild of relevant ebuilds at all.
Comment 14 Gaby Czegany 2019-10-15 03:37:05 UTC
Rebuilding all installed packages who have virtual/pam as dependency have naturally remove virtual/pam from my system:

 # qdepends -Qqq virtual/pam | sed 's/^/=/g' | xargs emerge -1
 # emerge --depclean
 >>> Unmerging (1 of 1) virtual/pam-0-r1...
Comment 15 Larry the Git Cow gentoo-dev 2019-10-15 13:38:19 UTC
The bug has been referenced in the following commit(s):

https://gitweb.gentoo.org/repo/gentoo.git/commit/?id=ab207de832114e7440c93e128b50ff2d58324d6a

commit ab207de832114e7440c93e128b50ff2d58324d6a
Author:     Michał Górny <mgorny@gentoo.org>
AuthorDate: 2019-10-15 13:35:18 +0000
Commit:     Michał Górny <mgorny@gentoo.org>
CommitDate: 2019-10-15 13:37:59 +0000

    profiles: Revert "mask virtual/pam"
    
    This mask has been done without proper revbump.  Users keep getting
    the message that virtual/pam is specific to FreeBSD, reporting bugs
    and sending annoying private mail.
    
    Next time, if you want to cause a major fallout like that, please
    kindly avoid hijacking other people's masks or bugs.  Thank you.
    
    Reverts: ada0d358cb90b28a623a6e5796e5877bc6271b41
    Bug: https://bugs.gentoo.org/697630#
    Signed-off-by: Michał Górny <mgorny@gentoo.org>

 profiles/package.mask | 1 -
 1 file changed, 1 deletion(-)
Comment 16 William Hubbs gentoo-dev 2019-10-15 17:17:31 UTC
There is another way to do this which I did on my home system:

# emerge --changed-deps y -NDuqa @world

I would debate the necessity of a revbump based on this.
Comment 17 Manfred Knick 2019-10-15 20:42:10 UTC
(In reply to Gaby Czegany from comment #14)
(In reply to William Hubbs from comment #16)

Just for comparison:

   Even after sorting out the basic problem manually

   and applying 
>  # qdepends -Qqq virtual/pam | sed 's/^/=/g' | xargs emerge -1
,
>  # emerge --changed-deps y -NDuqa @world
   finds following additional needs:

[ebuild   R   ] dev-libs/libevent-2.1.8 
[ebuild   R   ] app-eselect/eselect-opencl-1.1.0-r4 
[ebuild   R   ] dev-python/pexpect-4.2.1 
[ebuild   R   ] virtual/editor-0-r2 
[ebuild   R   ] dev-util/cbindgen-0.9.1 
[ebuild   R   ] dev-perl/Text-Iconv-1.700.0-r2 
[ebuild   R   ] dev-perl/Socket6-0.280.0 
[ebuild   R   ] dev-perl/Net-Daemon-0.480.0-r2 
[ebuild   R   ] dev-perl/URI-1.730.0 
[ebuild   R   ] dev-perl/XML-XPath-1.420.0 
[ebuild   R   ] dev-perl/HTML-Parser-3.720.0 
[ebuild   R   ] dev-perl/Encode-Locale-1.50.0 
[ebuild   R   ] dev-perl/Sub-Name-0.210.0 
[ebuild   R   ] dev-perl/XML-NamespaceSupport-1.120.0 
[ebuild   R   ] dev-perl/Locale-gettext-1.70.0 
[ebuild   R   ] dev-perl/XML-SAX-Base-1.90.0 
[ebuild   R   ] dev-perl/libintl-perl-1.280.0 
[ebuild   R   ] dev-perl/Text-Unidecode-1.300.0 
[ebuild   R   ] dev-perl/TermReadKey-2.370.0 
[ebuild   R   ] dev-perl/MailTools-2.190.0 
[ebuild   R   ] dev-perl/Text-CSV_XS-1.340.0 
[ebuild   R   ] dev-perl/PlRPC-0.202.0-r3 
[ebuild   R   ] dev-perl/IPC-Run-0.960.0 
[ebuild   R   ] dev-perl/Time-Duration-1.200.0 
[ebuild   R   ] dev-perl/HTTP-Message-6.130.0 
[ebuild   R   ] dev-perl/IO-Socket-SSL-2.52.0 
[ebuild   R   ] dev-perl/Try-Tiny-0.300.0 
[ebuild   R   ] dev-perl/WWW-RobotRules-6.20.0-r1 
[ebuild   R   ] dev-perl/Module-Build-0.422.400 
[ebuild   R   ] dev-perl/XML-SAX-1.0.0 
[ebuild   R   ] dev-perl/Text-CSV-1.950.0 
[ebuild   R   ] dev-perl/Archive-Zip-1.640.0 
[ebuild   R   ] dev-perl/DBI-1.637.0 
[ebuild   R   ] dev-perl/File-BaseDir-0.70.0 
[ebuild   R   ] dev-perl/HTTP-Cookies-6.40.0 
[ebuild   R   ] dev-perl/HTTP-Daemon-6.10.0-r2 
[ebuild   R   ] dev-perl/HTTP-Negotiate-6.10.0-r1 
[ebuild   R   ] dev-perl/IO-Socket-INET6-2.720.0-r1 
[ebuild   R   ] dev-perl/SGMLSpm-1.1-r1 
[ebuild   R   ] dev-perl/Error-0.170.250 
[ebuild   R   ] dev-perl/XML-LibXML-2.13.200 
[ebuild   R   ] dev-perl/Net-HTTP-6.170.0 
[ebuild   R   ] dev-perl/File-DesktopEntry-0.220.0 
[ebuild   R   ] media-video/lsdvd-0.17 
[ebuild   R   ] dev-perl/libwww-perl-6.270.0 
[ebuild   R   ] dev-perl/XML-Twig-3.520.0 
[ebuild   R   ] dev-perl/LWP-Protocol-https-6.70.0 
[ebuild   R   ] app-text/po4a-0.47-r1 
[ebuild   R   ] media-libs/libmtp-1.1.16 
[ebuild   R   ] dev-libs/boehm-gc-8.0.4 
[ebuild   R   ] dev-perl/File-MimeInfo-0.280.0 
[ebuild   R   ] sys-apps/dbus-1.12.16 
[ebuild   R   ] dev-perl/Net-DBus-1.1.0 
[ebuild   R   ] app-text/libetonyek-0.1.9 
[ebuild   R   ] media-libs/lensfun-0.3.2-r1 
[ebuild   R   ] dev-libs/grantlee-5.1.0 
[ebuild   R   ] dev-libs/kdiagram-2.6.1-r1 
[ebuild   R   ] x11-libs/cairo-1.16.0-r3 
[ebuild   R   ] app-emulation/libvirt-5.5.0-r1 
[ebuild   R   ] media-plugins/gst-plugins-vaapi-1.14.3 
[ebuild   R   ] dev-qt/qtwebkit-5.212.0_pre20180120        <--
[ebuild   R   ] virtual/notification-daemon-0 
[ebuild   R   ] media-video/vlc-3.0.8 
[ebuild   R   ] media-video/mplayer-1.3.0-r5 
[ebuild   R   ] dev-qt/qtwebengine-5.12.3 
[ebuild   R   ] www-client/firefox-68.1.0                  <--
[ebuild   R   ] media-video/transcode-1.1.7-r3 
[ebuild   R   ] kde-misc/kdiff3-1.8.1 

   including qtwebengine and firefox as long-time-consuming builds.
Comment 18 Chris Slycord 2019-10-16 00:50:19 UTC
(In reply to Manfred Knick from comment #17)
> (In reply to Gaby Czegany from comment #14)
> (In reply to William Hubbs from comment #16)
> 
> Just for comparison:
> 
>    Even after sorting out the basic problem manually
> 
>    and applying 
> >  # qdepends -Qqq virtual/pam | sed 's/^/=/g' | xargs emerge -1
> ,
> >  # emerge --changed-deps y -NDuqa @world
>    finds following additional needs:
> 
> [ebuild   R   ] dev-libs/libevent-2.1.8 
> [ebuild   R   ] app-eselect/eselect-opencl-1.1.0-r4 
> [ebuild   R   ] dev-python/pexpect-4.2.1 
> [ebuild   R   ] virtual/editor-0-r2 
> [ebuild   R   ] dev-util/cbindgen-0.9.1 
> [ebuild   R   ] dev-perl/Text-Iconv-1.700.0-r2 
> [ebuild   R   ] dev-perl/Socket6-0.280.0 
> [ebuild   R   ] dev-perl/Net-Daemon-0.480.0-r2 
> [ebuild   R   ] dev-perl/URI-1.730.0 
> [ebuild   R   ] dev-perl/XML-XPath-1.420.0 
> [ebuild   R   ] dev-perl/HTML-Parser-3.720.0 
> [ebuild   R   ] dev-perl/Encode-Locale-1.50.0 
> [ebuild   R   ] dev-perl/Sub-Name-0.210.0 
> [ebuild   R   ] dev-perl/XML-NamespaceSupport-1.120.0 
> [ebuild   R   ] dev-perl/Locale-gettext-1.70.0 
> [ebuild   R   ] dev-perl/XML-SAX-Base-1.90.0 
> [ebuild   R   ] dev-perl/libintl-perl-1.280.0 
> [ebuild   R   ] dev-perl/Text-Unidecode-1.300.0 
> [ebuild   R   ] dev-perl/TermReadKey-2.370.0 
> [ebuild   R   ] dev-perl/MailTools-2.190.0 
> [ebuild   R   ] dev-perl/Text-CSV_XS-1.340.0 
> [ebuild   R   ] dev-perl/PlRPC-0.202.0-r3 
> [ebuild   R   ] dev-perl/IPC-Run-0.960.0 
> [ebuild   R   ] dev-perl/Time-Duration-1.200.0 
> [ebuild   R   ] dev-perl/HTTP-Message-6.130.0 
> [ebuild   R   ] dev-perl/IO-Socket-SSL-2.52.0 
> [ebuild   R   ] dev-perl/Try-Tiny-0.300.0 
> [ebuild   R   ] dev-perl/WWW-RobotRules-6.20.0-r1 
> [ebuild   R   ] dev-perl/Module-Build-0.422.400 
> [ebuild   R   ] dev-perl/XML-SAX-1.0.0 
> [ebuild   R   ] dev-perl/Text-CSV-1.950.0 
> [ebuild   R   ] dev-perl/Archive-Zip-1.640.0 
> [ebuild   R   ] dev-perl/DBI-1.637.0 
> [ebuild   R   ] dev-perl/File-BaseDir-0.70.0 
> [ebuild   R   ] dev-perl/HTTP-Cookies-6.40.0 
> [ebuild   R   ] dev-perl/HTTP-Daemon-6.10.0-r2 
> [ebuild   R   ] dev-perl/HTTP-Negotiate-6.10.0-r1 
> [ebuild   R   ] dev-perl/IO-Socket-INET6-2.720.0-r1 
> [ebuild   R   ] dev-perl/SGMLSpm-1.1-r1 
> [ebuild   R   ] dev-perl/Error-0.170.250 
> [ebuild   R   ] dev-perl/XML-LibXML-2.13.200 
> [ebuild   R   ] dev-perl/Net-HTTP-6.170.0 
> [ebuild   R   ] dev-perl/File-DesktopEntry-0.220.0 
> [ebuild   R   ] media-video/lsdvd-0.17 
> [ebuild   R   ] dev-perl/libwww-perl-6.270.0 
> [ebuild   R   ] dev-perl/XML-Twig-3.520.0 
> [ebuild   R   ] dev-perl/LWP-Protocol-https-6.70.0 
> [ebuild   R   ] app-text/po4a-0.47-r1 
> [ebuild   R   ] media-libs/libmtp-1.1.16 
> [ebuild   R   ] dev-libs/boehm-gc-8.0.4 
> [ebuild   R   ] dev-perl/File-MimeInfo-0.280.0 
> [ebuild   R   ] sys-apps/dbus-1.12.16 
> [ebuild   R   ] dev-perl/Net-DBus-1.1.0 
> [ebuild   R   ] app-text/libetonyek-0.1.9 
> [ebuild   R   ] media-libs/lensfun-0.3.2-r1 
> [ebuild   R   ] dev-libs/grantlee-5.1.0 
> [ebuild   R   ] dev-libs/kdiagram-2.6.1-r1 
> [ebuild   R   ] x11-libs/cairo-1.16.0-r3 
> [ebuild   R   ] app-emulation/libvirt-5.5.0-r1 
> [ebuild   R   ] media-plugins/gst-plugins-vaapi-1.14.3 
> [ebuild   R   ] dev-qt/qtwebkit-5.212.0_pre20180120        <--
> [ebuild   R   ] virtual/notification-daemon-0 
> [ebuild   R   ] media-video/vlc-3.0.8 
> [ebuild   R   ] media-video/mplayer-1.3.0-r5 
> [ebuild   R   ] dev-qt/qtwebengine-5.12.3 
> [ebuild   R   ] www-client/firefox-68.1.0                  <--
> [ebuild   R   ] media-video/transcode-1.1.7-r3 
> [ebuild   R   ] kde-misc/kdiff3-1.8.1 
> 
>    including qtwebengine and firefox as long-time-consuming builds.

Likely, most of those are unrelated, by the way. For instance, the first two don't appear to depend on pam.

You're asking portage to rebuild everything with changed deps (whether they're pam-related or not). Which, in most situations isn't neccesary.
Comment 19 Tomáš Mózes 2019-10-16 03:29:03 UTC
(In reply to William Hubbs from comment #16)
> There is another way to do this which I did on my home system:
> 
> # emerge --changed-deps y -NDuqa @world
> 
> I would debate the necessity of a revbump based on this.

I think it's fine, but a news item should document it so people don't have to panic.
Comment 20 Manfred Knick 2019-10-16 08:29:38 UTC
(In reply to Chris Slycord from comment #18)
Correct.
Exactly that was intended by warning "long-time-consuming" at the end.

Thanks for elucidating the rationale more clearly.
Comment 21 Ulenrich 2019-10-16 14:56:16 UTC
(In reply to Larry the Git Cow from comment #15)
>     profiles: Revert "mask virtual/pam"
>     
>     This mask has been done without proper revbump.  Users keep getting
>     the message that virtual/pam is specific to FreeBSD, reporting bugs
>     and sending annoying private mail.

Does the bug owner see this bug is resolved by reverting the mask?